#!/usr/bin/php
<?php
if (isset($_SERVER['REMOTE_ADDR'])) {
    die('Direct access not permitted');
}
// This script will output a meterN compatible format for the main command
// You'll need to setup the path to meterN ($pathtomn). Put the meters numbers ($metnum) and the corresponding command ($cmd) :

$pathtomn = '/srv/http/metern';
$output = shell_exec('pkill -f poolmeters.py > /dev/null 2>&1 &'); // Kill temporary the "live values fetching"

if (isset($argv[1])) {
    if ($argv[1] == 'elect') {
        $metnum = 1;
        $cmd    = "$pathtomn/comapps/poolmeters.py relect"; // Request counters values during a 5 min period
    } elseif ($argv[1] == 'gas') {
        $metnum = 2;
        $cmd    = "$pathtomn/comapps/poolmeters.py rgas";
    } elseif ($argv[1] == 'water') {
        $metnum = 3;
        $cmd    = "$pathtomn/comapps/poolmeters.py rwater";
    } else {
        die('Abording: no valid argument given\n');
    }
} else {
    die("Usage: pooler { elect | gas | water }\n");
}
// End of setup

define('checkaccess', TRUE);
include("$pathtomn/config/config_main.php");
include("$pathtomn/config/config_met$metnum.php");

// Retrieve previous value in the last daily csv
$dir    = "$pathtomn/data/csv";
$output = glob($dir . '/*.csv');
sort($output);
$cnt  = count($output);
$file = file($output[$cnt - 1]);
$cnt  = count($file);

$i = 0;
while (!isset($prevval)) {
    $i++;
    $array = preg_split('/,/', $file[$cnt - $i]);
    if (!empty($array[$metnum])) {
        $prevval = $array[$metnum];
    }
    if ($i == $cnt) {
        $prevval = 0; // didn't find any prev. value
    }
}

// Now retrieve the current value

$datareturn = shell_exec($cmd);
$datareturn = trim($datareturn);
$datareturn = preg_replace("/^${'ID'.$metnum}\(/i", '', $datareturn); // VALUE*UNIT)
$lastval    = preg_replace("/\*[a-z0-9]+\)$/i", '', $datareturn); // VALUE
settype($lastval, 'float');
settype($prevval, 'float');
$lastval += $prevval;

if (${'PASSO' . $metnum} > 0 && $lastval > ${'PASSO' . $metnum}) { // counter pass over
    $lastval -= ${'PASSO' . $metnum};
}
$lastval = round($lastval, ${'PRECI' . $metnum});
$str     = utf8_decode("${'ID'.$metnum}($lastval*${'UNIT'.$metnum})\n");
echo "$str";

if ($argv[1] == 'water') {
    $output = shell_exec("$pathtomn/comapps/poolmeters.py live > /dev/null 2>&1 &"); // Restart live fetching at the last counter request
}
?>
